from tkinter import *
def array(N1, N2=0,init=0):   #■配列宣言
    if N2==0: return [init for i in range(N1)]
    return [[init for i in range(N2)] for j in range(N1)]
def cycInc(Pno,N):#■サイクリックなカウント
    M=Pno+1
    if M>=N:return 0
    return M
def copyDT(DT):#■ナンプレ問題複写
    SQR=array(9,9)
    for i in range(9):
        for j in range(9):SQR[i][j]=DT[i][j]
    return SQR
def insertList(L,num):#■リスト挿入
    R=[];R.append(num)
    for i in range(len(L)):
        if L[i]!=num:R.append(L[i])
    return R
def delList(MM,Num):#■リスト削除
    R=[]
    for k in range(len(MM)):
        if MM[k]!=Num:R.append(MM[k])
    return R
def endCheck(DT):#■全確定チェック
    for i in range(len(DT)):
        for j in range(len(DT[i])):
            if DT[i][j]==0:return False
    return True
def errStr(i,j,S):
    return "%d"%(i+1)+S+" 値%d"%(j+1)
def errCheck(DT):#■エラーチェック
    for i in range(9):
        CHK=array(9) #行方向チェック
        for j in range(9):CHK[DT[i][j]-1]+=1
        for j in range(9):
            if CHK[j]>1:return errStr(i,j,"行")
        CHK=array(9) #列方向チェック
        for j in range(9):CHK[DT[j][i]-1]+=1
        for j in range(9):
            if CHK[j]>1:return errStr(i,j,"列")
    for ix in range(0,9,3):#ブロック別チェック
        for iy in range(0,9,3):
            CHK=array(9)
            for i in range(3):
                ii=ix+i
                for j in range(3):
                    jj=iy+j;CHK[DT[jj][ii]-1]+=1
                for j in range(9):
                    if CHK[j]>1:
                        return("%d,%d"%((ix+1),(iy+1))+
                               "ブロック 値%d"%(j+1))
    return ""            
def drawNum(canvas,X,Y,Num,tag="DT"):#■大きな数字の表示
    global imageTB
    try:
        return canvas.create_image(X-18,Y-18,anchor=NW,
                                   image=imageTB[Num-1],
                                   tag=tag)
    except:
        canvas.create_rectangle(X-21,Y-21,X+21,Y+21,fill="",tag=tag)
        return canvas.create_text(X,Y,text="%d"%Num,tag=tag,
                                  font=("monospace",28,"bold"))
    
def drawRec(canvas,X1,Y1,X2,Y2,CL,tag="bk",outline="black"):
    return canvas.create_rectangle(X1,Y1,X2,Y2,fill=CL,tag=tag)
def drawBnd(canvas,X1,Y1,X2,Y2,tag="bk"):
    canvas.create_line(X1,Y1,X2,Y2,fill="black",width=2,tag=tag)
def drawShad(canvas,X1,Y1,X2,Y2):
    canvas.create_line(X1,Y1,X2,Y2,
                       fill="#777777",width=2,tag="bk")
def drawSQRonly(canvas,SZ,X0,Y0,DT):#■ナンプレ正方形の描画
    global imageTB
    canvas.delete('bk');canvas.delete('DT')#画面クリア
    SQR=array(9,9)#ナンプレ正方形を描く
    for i in range(9):
        Y=i*SZ+Y0
        for j in range(9):
            X=j*SZ+X0; CL="white"
            #print("loop",i,j)
            if DT[i][j]!=0:CL="#77FFFF"#可視部分の背景
            SQR[i][j]=drawRec(canvas,X,Y,X+SZ,Y+SZ,CL)
            if DT[i][j]!=0:#可視部分の数字表示
                drawNum(canvas,X+SZ/2,Y+SZ/2,DT[i][j])
    X1=X0+9*SZ
    for i in range(4):Y=i*SZ*3+Y0;drawBnd(canvas,X0,Y,X1,Y)#横太線
    Y1=Y0+9*SZ
    for i in range(4):X=i*SZ*3+X0;drawBnd(canvas,X,Y0,X,Y1)#縦太線
    return SQR
def drawSQR(canvas,SZ,X0,Y0,DT):#■初期画面を描く
    global imageTB;
    SQR=drawSQRonly(canvas,SZ,X0,Y0,DT)
    NUM=array(9)
    X=X0+10*SZ
    for i in range(9):#数字選択部分
        Y=i*SZ+Y0;
        drawRec(canvas,X,Y,X+SZ,Y+SZ,"#CCCCCC",outline="#EEEEEE")
        NUM[i]=drawNum(canvas,X+SZ/2,Y+SZ/2,i+1,tag="bk")
    X=X0+10*SZ
    canvas.create_text(X+SZ/2,Y0-10,text="絵柄選択",
                       font=("monospace",10),tag="bk")        
    for i in range(9):#数字選択部分の影用の直線(横)
        Y=i*SZ+Y0; drawShad(canvas,X+2,Y+SZ,X+SZ,Y+SZ)
    X=X0+11*SZ
    for i in range(9):#数字選択部分の影用の直線(縦)
        Y=i*SZ+Y0; drawShad(canvas,X,Y+2,X,Y+SZ)
    return [SQR,NUM]
def drawSmall(canvas,X,Y,LM):#■小さな数字の表示
    global imageTS
    try:
        canvas.create_image(X-6,Y-6,anchor=NW,
                            image=imageTS[LM-1],
                            tag="DT")
    except:
        canvas.create_text(X,Y,text="%d"%LM,
                           font=("monospace",9,"bold"),
                           tag="DT")
def drawNumber(canvas,X0,Y0,SZ,DT,Memo):#■ナンプレ数字の描画
    canvas.delete("DT");SZ3=SZ/3
    for i in range(9):
        Y=i*SZ+Y0
        for j in range(9):
            X=j*SZ+X0
            if DT[i][j]!=0:#確定数字描画
                drawNum(canvas,X+SZ/2,Y+SZ/2,DT[i][j])
            elif Memo[i][j]!=[]:
                MM=Memo[i][j]#メモ描画
                for k in range(len(MM)):
                    LM=MM[k]
                    LX=(    (LM-1) % 3)*SZ3+SZ3/2
                    LY=(int((LM-1) / 3))*SZ3+SZ3/2
                    drawSmall(canvas,X+LX,Y+LY,LM)
imageTB=array(9);imageTS=array(9)
def imageRead():
    global imageTB,imageTS
    for i in range(9):
        FnameB="gif/B0%d.gif" %(i+1)
        FnameS="gif/S0%d.gif" %(i+1)
        imageTB[i]=PhotoImage(file=FnameB)
        imageTS[i]=PhotoImage(file=FnameS)

    return [imageTB,imageTS]
